﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public WorkingFolder As String 
	
	Public Const DEBUG_MODE As Boolean = True 
	Public Const ERROR_LOG_FILE As String = "ErrorLog.txt"
	
	Private Const PROGRAM_FOLDER As String = "WaitForTest"	
	
End Sub

Sub Service_Create

	' make us a folder
	WorkingFolder = GetDBFolder
	If File.Exists(File.Combine(WorkingFolder, PROGRAM_FOLDER), "") = False Then
		' create the folder
		File.MakeDir(WorkingFolder, PROGRAM_FOLDER)
	End If
	' save the completed path
	WorkingFolder = File.Combine(WorkingFolder, PROGRAM_FOLDER)
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (ERROR As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub


Private Sub GetDBFolder As String
	Dim rp As RuntimePermissions
	If File.ExternalWritable Then Return rp.GetSafeDirDefaultExternal("") Else Return File.DirInternal
End Sub