﻿B4A=true
Group=Classes
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
'#IgnoreWarnings: 9

'  LIBRARY REQUIREMENTS: Core, OkHttpUtils2, XmlSax
 
Sub Class_Globals
	#Event: CG_Complete(Success As Boolean)
	
	Type cgResultParms(TransportKey As String, Status As String, AmountApproved As Double, AuthorizationCode As String, _
						Cardholder As String, AccountNumber As String, PaymentType As String, CardType As Int, EntryMode As String, _
						ErrorMessage As String, Token As String, TransactionDate As String, TransactionType As String, _
						ResponseType As String, ValidationKey As String, SignatureData As String, UserTip As Double, _
						Cashback As Double, Donation As Double, Surcharge As Double, RemainingCardBalance As Double, _
						DiscountTotal As Double, KeyedExpDate As String, KeyedAvsZip As String, KeyedAvsResponse As String, _
						KeyedCvResponse As String, ExtraData As String, DebitTraceNumber As String, _
						VaultToken As String, VaultErrorCode As String, VaultErrorMsg As String, VaultExpire As String)

	Type cgPoint(X As Int, Y As Int)

	Type cgStageParmeters(TransType As Int, Amount As Double, ClerkID As String, InvoiceNumber As String, DBA As String, _
							TransactionId As String, ForceDuplicate As Boolean, CustomerCode As String, PONumber As String, _
							TaxAmount As Double, TerminalID As Int, AuthCode As String, EligibleTipAmount As Double, _
							StoreCardInVault As Boolean)
	
	Type cgVaultParmeters(VaultToken As String, Amount As Double, InvoiceNumber As String,  TransactionId As String, _
							CustomerCode As String, TaxAmount As Double, TerminalID As Int, ForceDuplicate As Boolean, _
							EnablePartialAuth As Boolean)

	Type cgDeviceStatus(Status As String, CurrentScreen As Int, ResponseMessage As String, SerialNumber As String, AppVer As String, _
						OSVer As String)
	
	Public Const Trans_Sale As Int = 1
	Public Const Trans_Refund As Int = 2
	Public Const Trans_Level2Sale As Int = 3
	Public Const Trans_PreAuth As Int = 4
	Public Const Trans_ForceSale As Int = 5
	Public Const Trans_AddValue As Int = 6
	Public Const Trans_BalanceInquiry As Int = 7
	Public Const Trans_AddToValut As Int = 8
	Public Const Trans_RemoveFromValut As Int = 9

	
	Public Const ART_Card_None As Int = 0
	Public Const ART_Card_Visa As Int = 1
	Public Const ART_Card_Master As Int = 2
	Public Const ART_Card_AmEx As Int = 3
	Public Const ART_Card_Discover As Int = 4
	Public Const ART_Card_Debit As Int = 5
	Public Const ART_Card_Gift As Int = 6
	Public Const ART_Card_EBT As Int = 7
	Public Const ART_Card_LevelUp As Int = 8
	Public Const ART_Card_Voyager As Int = 9
	Public Const ART_Card_Wex As Int = 10
	Public Const ART_Card_JCB As Int = 11
	Public Const ART_Card_CUP As Int = 12
	Public Const ART_Card_Diners As Int = 13
	Public Const ART_Card_PhxGift As Int = 14
	Public Const ART_Card_PhxReward As Int = 15
	Public Const ART_Card_Other As Int = 99
	
'	
	
	Public Const ART_EntryMode_None As Int = 0
	Public Const ART_EntryMode_Swipe As Int = 1
	Public Const ART_EntryMode_Proximity As Int = 2
	Public Const ART_EntryMode_Barcode As Int = 3
	Public Const ART_EntryMode_Manual As Int = 4
	Public Const ART_EntryMode_Note As Int = 5

	Public ShowDebugLog As Boolean = True
	Public ShowDebugXML As Boolean = False
	

	Public Const DS_Unknown As Int = -1
	Public Const DS_IdleScreen As Int = 0
	Public Const DS_ValidatingTransKey As Int = 1
	Public Const DS_MainPaymentCollection As Int = 2
	Public Const DS_CustomPaymentCollection As Int = 3
	Public Const DS_LookingUpCardBIN As Int = 4
	Public Const DS_WaitingForAmountConfirmation As Int = 5
	Public Const DS_WaitingForPINEntry As Int = 6
	Public Const DS_ProcessingPayment As Int = 7
	Public Const DS_WaitingForSignature As Int = 8
	Public Const DS_ProcessingSignature As Int = 9
	Public Const DS_TransactionResult As Int = 10
	Public Const DS_CancelConfirm As Int = 11
	Public Const DS_RunAsCreditConfirm As Int = 12
	Public Const DS_SKUDisplay As Int = 13
	Public Const DS_CashbackSelection As Int = 14
	Public Const DS_CashbackCustom As Int = 15
	Public Const DS_TipSelection As Int = 16
	Public Const DS_TipCustom As Int = 17
	Public Const DS_DonationSelection As Int = 18
	Public Const DS_DonationCustom As Int = 19
	Public Const DS_ConfirmationScreen As Int = 20
	Public Const DS_ErrorScreen As Int = 24
	Public Const DS_SKUAmountConfirm As Int = 26
	Public Const DS_PANEntryn As Int = 27
	Public Const DS_ExpireEntry As Int = 28
	Public Const DS_CVVEntry As Int = 29
	Public Const DS_ZipEntry As Int = 30
	Public Const DS_AgreementScreen As Int = 31
	Public Const DS_AgreementCapture As Int = 32
	Public Const DS_EMVApplicationSelection As Int = 33
	Public Const DS_GetCustomerInput As Int = 35
	Public Const DS_GiftCardCapture As Int = 36
	Public Const DS_NetworkDetails As Int = 38
	Public Const DS_NetworkConfig As Int = 3
	

	Private Const INTERFACE_VERSION As String = "1.0.0"
	Private Const SOFTWARE_NAME As String = "TestSW"
	Private Const STAGING_ENDPOINT As String = "https://transport.merchantware.net/v4/transportService.asmx"
	Private Const CREDIT_ENDPOINT As String = "https://ps1.merchantware.net/Merchantware/ws/RetailTransaction/v46/Credit.asmx"
	Private Const CREDIT_ENDPOINT_45 As String = "https://ps1.merchantware.net/Merchantware/ws/RetailTransaction/v45/Credit.asmx"
	Private Const CALLBACK_EVENT As String = "CG_Complete"
	
	Private moCallBack As Object = Null
	Private moResponse As cgResultParms
	Private msTransportKey As String
	Private msValidationKey As String
	Private msLastError As String
	Private msRawResponse As String
	Private msRawDeviceResponse As String
	Private mbAbort As Boolean
	Private mbSwipeComplete As Boolean
	
	Private msDeviceIP As String
	Private msMerchantName As String
	Private msMerchantSiteID As String
	Private msMerchantKey As String
End Sub


Public Sub Initialize(Callback As Object, DeviceIP As String, MerchantName As String, MerchantSiteID As String, MerchantKey As String)
	moCallBack = Callback
	msDeviceIP = DeviceIP
	msMerchantName = MerchantName
	msMerchantSiteID = MerchantSiteID
	msMerchantKey = MerchantKey


	Reset
End Sub

Public Sub Abort
	mbAbort = True
End Sub


Public Sub Reset
	msTransportKey = ""
	msValidationKey = ""
	msLastError = ""
	msRawResponse = ""
	msRawDeviceResponse = ""
	mbSwipeComplete = False
	
	moResponse.Initialize
	moResponse.EntryMode = ""
	moResponse.Status = "UNDEFINED"
	mbAbort= False
End Sub





' Returns device status, should be a resumable sub:
' <code>
' poCG.DeviceGetStatus
' Wait For CG_Complete(Result As cgDeviceStatus)
' </code>
Public Sub DeviceGetStatus As ResumableSub
	Dim poJob As HttpJob
	Dim poResult As cgDeviceStatus

	Reset
	poResult.Initialize
	poResult.CurrentScreen = DS_Unknown
	poResult.Status = "Error communicating with device"

	If msDeviceIP <> "" Then
		Dlog("Requesting device status...", Colors.Magenta)
		Dim psRequest As String =   $"http://${msDeviceIP}:8080/v2/pos?Action=Status&Format=XML"$
		' issue request to device
		poJob.Initialize("", Me)
		Try
			' send HTTP request
			poJob.GetRequest.Timeout = 15000
			poJob.Download(psRequest)
			' wait for completion
			Wait For (poJob) JobDone(poJob As HttpJob)
			msRawDeviceResponse = poJob.GetString
			If poJob.Success Then
				Dim poTree As clsXmlTree = ParseXML(msRawDeviceResponse)
				If poTree.TreeIsEmpty  Then
					msLastError = "Unknown response from device for status query: " & msRawDeviceResponse
				Else
					poResult.Status = poTree.GetNodeTextFromRoot("Status")
					Dim psVal As String = poTree.GetNodeTextFromRoot("CurrentScreen")
					If IsNumber(psVal) Then
						poResult.CurrentScreen = psVal
					Else
						poResult.CurrentScreen = DS_Unknown
					End If
					poResult.ResponseMessage = poTree.GetNodeTextFromRoot("ResponseMessage")
					poResult.SerialNumber = poTree.GetNodeTextFromRoot("SerialNumber")
					poResult.AppVer = poTree.GetNodeTextFromRoot("ApplicationVersion")
					poResult.OSVer = poTree.GetNodeTextFromRoot("OSVersion")
				End If
			Else
				msLastError = poJob.ErrorMessage
			End If
		Catch
			msLastError = " Device Error: " & LastException.Message
		End Try
		poJob.Release
	End If
	If msLastError <> "" Then
		LogColor("clsCayanGenius.DeviceGetStatus: " & msLastError, Colors.Red)
	Else
		Dlog("Device status request complete.", Colors.Magenta)
	End If
	
	Return poResult
End Sub

' Cancels current Genius transaction, should be a resumable sub:
' <code>
' Wait For (poCG.DeviceCancelTransaction) Complete(Result As cgDeviceStatus)
' </code>
Public Sub DeviceCancelTransaction As ResumableSub
	Dim poJob As HttpJob
	Dim poResult As cgDeviceStatus

	Reset
	poResult.Initialize
	poResult.Status = "Error communicating with device"

	If msDeviceIP <> "" Then
		Dim psRequest As String =   $"http://${msDeviceIP}:8080/v2/pos?Action=Cancel&Format=XML"$
		' issue request to device
		poJob.Initialize("", Me)
		Try
			' send HTTP request
			poJob.GetRequest.Timeout = 15000
			poJob.Download(psRequest)
			' wait for completion
			Wait For (poJob) JobDone(poJob As HttpJob)
			msRawDeviceResponse = poJob.GetString
			If poJob.Success Then
				Dim poTree As clsXmlTree = ParseXML(msRawDeviceResponse)
				If poTree.TreeIsEmpty  Then
					msLastError = "Unknown response from device for status query: " & msRawDeviceResponse
				Else
					poResult.Status = poTree.GetNodeTextFromRoot("Status")
					poResult.CurrentScreen = DS_IdleScreen
					poResult.ResponseMessage = poTree.GetNodeTextFromRoot("ResponseMessage")
				End If
			Else
				msLastError = poJob.ErrorMessage
			End If
		Catch
			msLastError = " Device Error: " & LastException.Message
		End Try
		poJob.Release
	End If
	If msLastError <> "" Then
		LogColor("clsCayanGenius.DeviceCancelTransaction: " & msLastError, Colors.Red)
	End If
	Return poResult
End Sub




Public Sub GeniusTransactionSwipe(StageParams As cgStageParmeters)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	

	Reset
	psData = BuildStageTransXML(StageParams)

	Dlog("Getting transport key...", Colors.Magenta)

	poJob.Initialize("", Me)
	Try
		psURL = BuildStagingURL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 30000
		poJob.PostString(psURL, psData)
		poJob.GetRequest.SetHeader("SOAPAction", "http://transport.merchantware.net/v4/CreateTransaction")
		poJob.GetRequest.SetContentType("text/xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			msTransportKey = poTree.GetNodeTextFromRoot("transportKey")
			msValidationKey = poTree.GetNodeTextFromRoot("validationKey")
			If msTransportKey <> "" Then
				pbSuccess = True
			Else
				msLastError = poTree.GetNodeTextFromRoot("ErrorMessage")
				If msLastError = Null Or msLastError = "" Or msLastError = "null" Then
					msLastError = poTree.GetNodeTextFromRoot("Information")
				End If
			End If
		Else
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	' if success talk to device
	If pbSuccess And msTransportKey <> "" Then
		Dim psRequest As String =  $"http://${msDeviceIP}:8080/v2/pos?TransportKey=${msTransportKey}&Format=XML"$
		
		' issue request to device
		pbSuccess = False
		poJob.Initialize("", Me)
		Try
			' send HTTP request
			poJob.GetRequest.Timeout = 120000
			Dlog("Requesting from: " & psRequest, Colors.Magenta)
			poJob.Download(psRequest)
			' wait for completion
			Wait For (poJob) JobDone(poJob As HttpJob)
			msRawDeviceResponse = poJob.GetString
			mbSwipeComplete = True
			If poJob.Success Then
				Dim poTree As clsXmlTree = ParseXML(msRawDeviceResponse)
				
				modMain.MyLogB(msRawDeviceResponse)
				
				If Not(mbAbort) Then
					ParseResponseXML(poTree)
				End If
				pbSuccess = True
			Else
				LogColor("HTTP ERROR: " & poJob.ErrorMessage, Colors.Red)
				msLastError = poJob.ErrorMessage
			End If
		Catch
			pbSuccess = False
			msLastError = " Device Error: " & LastException.Message
		End Try
		poJob.Release
	End If
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			LogColor("clsCayanGenius.GeniusTransacitonSwipe: Invoking " & CALLBACK_EVENT & " callback. ", Colors.Magenta)
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess)
		End If
	End If
End Sub



Public Sub GeniusTransactionKeyed(StageParams As cgStageParmeters)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	

	Reset
	psData = BuildStageTransXML(StageParams)

	Dlog("Keyed swipe getting transport key...", Colors.Magenta)


	poJob.Initialize("", Me)
	Try
		psURL = BuildStagingURL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 30000
		poJob.PostString(psURL, psData)
		poJob.GetRequest.SetHeader("SOAPAction", "http://transport.merchantware.net/v4/CreateTransaction")
		poJob.GetRequest.SetContentType("text/xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			msTransportKey = poTree.GetNodeTextFromRoot("transportKey")
			msValidationKey = poTree.GetNodeTextFromRoot("validationKey")
			pbSuccess = True
		Else
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	' if success talk to device
	If pbSuccess And msTransportKey <> "" Then
		' begin a swiped trans
		Dim plStart As Long = DateTime.Now
		Dim pbOnScreen As Boolean = False
		
		Dlog("Begin card trans (pre-swipe)", Colors.Magenta)
		BeginSwipedTrans
		Dlog("waiting for device swipe screen ", Colors.Magenta)
		Sleep(600)

		Do While Not(mbAbort) And (DateTime.Now - plStart) < 120000 And Not(pbOnScreen)
			LogColor("Checking device status, before wait-for.", Colors.Magenta)
			Wait For (DeviceGetStatus) Complete(Status As cgDeviceStatus)
			Dlog("keyed status wait loop, device screen code is "& Status.CurrentScreen, Colors.Magenta)
			If Status.CurrentScreen = DS_MainPaymentCollection Then
				pbOnScreen = True
				Exit
			Else
				Dlog("Not swipe screen - " & Status.CurrentScreen, Colors.Magenta)
				If Status.CurrentScreen = DS_Unknown Then
					Exit  'some error
				Else
					Sleep(250)
				End If
			End If
		Loop
		Dlog("Done waiting for device swipe screen", Colors.Magenta)
		If pbOnScreen And Not(mbAbort) Then
			Dim psRequest As String =  $"http://${msDeviceIP}:8080/v2/pos?Action=InitiateKeyedEntry&Format=XML"$
			pbSuccess = False
			poJob.Initialize("", Me)
			Try
				' send HTTP request
				poJob.GetRequest.Timeout = 120000
				Dlog("Starting keyed input request from: " & psRequest, Colors.Magenta)
				poJob.Download(psRequest)
				' wait for completion
				Wait For (poJob) JobDone(poJob As HttpJob)
				msRawDeviceResponse = poJob.GetString
				If poJob.Success Then
					Dim poTree As clsXmlTree = ParseXML(msRawDeviceResponse)
					Dim poNode As xtXmlElement = poTree.GetNodeFromRoot("InitiateKeyedEntryResult")
					If poNode <> Null And poNode.IsInitialized Then
						Dim psText As String = poTree.GetNodeText(poNode.Children, "Status")
						If psText.Trim.ToLowerCase = "success" Then
							pbSuccess = True
						End If
					End If
					If pbSuccess Then
						Dlog("Keyed sent, waiting for swipe completion.", Colors.Magenta)
						' wait for swipe complete
						plStart = DateTime.Now
						Do While Not(mbAbort) And (DateTime.Now - plStart) < 120000 And Not(mbSwipeComplete)
							Sleep(250)
						Loop
					End If
				Else
					msLastError = poJob.ErrorMessage
				End If
			Catch
				pbSuccess = False
				msLastError = " Device Error: " & LastException.Message
			End Try
			poJob.Release
		End If
	End If
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess) 'ignore
		End If
	End If
End Sub


Public Sub MwApiSaleTransaction(VaultParms As cgVaultParmeters)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	
	Reset
	psData = BuildApiVaultSaleXML(VaultParms)

	poJob.Initialize("", Me)
	Try
		Dlog("Initiating vault sale", Colors.Magenta)
		psURL = BuildCreditURL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 120000
		poJob.PostString(psURL, psData)
		poJob.GetRequest.SetContentType("application/soap+xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dlog("Vault sale complete", Colors.Magenta)
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			Dlog("Vault sale raw result: " & CRLF & msRawResponse, Colors.blue)
			ParseSaleResponseXML(poTree)
			pbSuccess = True
		Else
			Dlog("Vault sale JOB HTTP error: " & poJob.ErrorMessage, Colors.Magenta)
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		LogColor("clsCayanGenius.MwApiVaultSale: " & LastException.Message, Colors.Red)
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess) 'ignore
		End If
	End If
End Sub

Public Sub MwApiVoidTransaction(VaultParms As cgVaultParmeters)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	
	Reset
	psData = BuildApiVoidRequestXML(VaultParms)

	poJob.Initialize("", Me)
	Try
		Dlog("Initiating void", Colors.Magenta)
		psURL = BuildCreditURL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 120000
		poJob.PostString(psURL, psData)
		poJob.GetRequest.SetContentType("application/soap+xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dlog("Void complete", Colors.Magenta)
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			Dlog("Void raw result: " & CRLF & msRawResponse, Colors.blue)
			ParseVoidResponseXML(poTree)
			pbSuccess = True
		Else
			Dlog("Void JOB HTTP error: " & poJob.ErrorMessage, Colors.Magenta)
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		LogColor("clsCayanGenius.MwApiVoidTransaction: " & LastException.Message, Colors.Red)
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess) 'ignore
		End If
	End If
End Sub


Public Sub MwApiRefundTransaction(VaultParms As cgVaultParmeters)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	
	Reset
	psData = BuildApiRefundRequestXML(VaultParms)

	poJob.Initialize("", Me)
	Try
		Dlog("Initiating refund", Colors.Magenta)
		psURL = BuildCreditURL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 120000
		poJob.PostString(psURL, psData)
		poJob.GetRequest.SetContentType("application/soap+xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dlog("Refund complete", Colors.Magenta)
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			Dlog("Refund raw result: " & CRLF & msRawResponse, Colors.blue)
			ParseRefundResponseXML(poTree)
			pbSuccess = True
		Else
			Dlog("Refund JOB HTTP error: " & poJob.ErrorMessage, Colors.Magenta)
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		LogColor("clsCayanGenius.MwApiRefundTransaction: " & LastException.Message, Colors.Red)
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess) 'ignore
		End If
	End If
End Sub


' Currently using MerchantWARE API 4.5 and not 4.6
Public Sub MwApiBoardCard(Token As String)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	
	Reset
	psData = BuildApiBoardRequestXML(Token)

	poJob.Initialize("", Me)
	Try
		Dlog("Initiating Board", Colors.Magenta)
		psURL = BuildCredit45URL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 120000
		poJob.PostString(psURL, psData)
		'poJob.GetRequest.SetContentType("application/soap+xml; charset=utf-8")
		' !!! WARNING !!!!   USING 4.5 API content tye
		poJob.GetRequest.SetContentType("text/xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dlog("Board complete", Colors.Magenta)
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			Dlog("Board raw result: " & CRLF & msRawResponse, Colors.blue)
			ParseBoardResponseXML(poTree)
			pbSuccess = (moResponse.Status <> "UNDEFINED")
		Else
			Dlog("Void JOB HTTP error: " & poJob.ErrorMessage, Colors.Magenta)
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		LogColor("clsCayanGenius.MwApiBoardCard: " & LastException.Message, Colors.Red)
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess) 'ignore
		End If
	End If
End Sub

Public Sub MwApiUnboardCard(Token As String)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	
	Reset
	psData = BuildApiUnboardRequestXML(Token)

	poJob.Initialize("", Me)
	Try
		Dlog("Initiating Unboard", Colors.Magenta)
		psURL = BuildCreditURL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 120000
		poJob.PostString(psURL, psData)
		poJob.GetRequest.SetContentType("application/soap+xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dlog("Unboard complete", Colors.Magenta)
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			Dlog("Unboard raw result: " & CRLF & msRawResponse, Colors.blue)
			ParseUnboardResponseXML(poTree)
			pbSuccess = (moResponse.Status <> "UNDEFINED")
		Else
			Dlog("Void JOB HTTP error: " & poJob.ErrorMessage, Colors.Magenta)
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		LogColor("clsCayanGenius.MwApiUnboardCard: " & LastException.Message, Colors.Red)
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess) 'ignore
		End If
	End If
End Sub

Public Sub MwApiFindBoardedCard(Token As String)
	Dim poJob As HttpJob
	Dim psURL As String
	Dim psData As String
	Dim pbSuccess As Boolean = False
	
	Reset
	psData = BuildApiFindBoardedCardRequestXML(Token)

	poJob.Initialize("", Me)
	Try
		Dlog("Initiating Find Boarded", Colors.Magenta)
		psURL = BuildCreditURL(Null)
		' send HTTP POST request
		poJob.GetRequest.Timeout = 120000
		poJob.PostString(psURL, psData)
		poJob.GetRequest.SetContentType("application/soap+xml; charset=utf-8")
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawResponse = poJob.GetString
		If poJob.Success Then
			Dlog("Find boarded complete", Colors.Magenta)
			Dim poTree As clsXmlTree = ParseXML(msRawResponse)
			Dlog("Find boarded raw result: " & CRLF & msRawResponse, Colors.blue)
			ParseFindBoardedCardResponseXML(poTree)
			pbSuccess = (moResponse.Status <> "UNDEFINED")
		Else
			Dlog("Void JOB HTTP error: " & poJob.ErrorMessage, Colors.Magenta)
			msLastError = poJob.ErrorMessage
		End If
		
	Catch
		pbSuccess = False
		LogColor("clsCayanGenius.MwApiUnboardCard: " & LastException.Message, Colors.Red)
		msLastError = " Network Error: " & LastException.Message
	End Try
	poJob.Release
	
	' notifiy sender
	If moCallBack <> Null And Not(mbAbort) Then
		If SubExists(moCallBack, CALLBACK_EVENT) Then
			CallSubDelayed2(moCallBack, CALLBACK_EVENT, pbSuccess) 'ignore
		End If
	End If
End Sub















'  Returns response parameter as CsBuidler object
Public Sub DebugDumpResponse As Object
	Dim poCS As CSBuilder
	
	poCS.Initialize
	poCS.Color(Colors.Blue).Append("TransportKey  - [").color(Colors.Magenta).Bold.Append(moResponse.TransportKey).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Status  - [").color(Colors.Magenta).Bold.Append(moResponse.Status).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("AmmountApproved  - [").color(Colors.Magenta).Bold.Append(moResponse.AmountApproved).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("AuthCode  - [").color(Colors.Magenta).Bold.Append(moResponse.AuthorizationCode).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Cardholder - [").color(Colors.Magenta).Bold.Append(moResponse.Cardholder).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("CardType - [").color(Colors.Magenta).Bold.Append(moResponse.CardType).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("AccountNumber  - [").color(Colors.Magenta).Bold.Append(moResponse.AccountNumber).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("PaymentType  - [").color(Colors.Magenta).Bold.Append(moResponse.PaymentType).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("EntryMode  - [").color(Colors.Magenta).Bold.Append(moResponse.EntryMode).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("ErrorMess  - [").color(Colors.Magenta).Bold.Append(moResponse.ErrorMessage).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Token  - [").color(Colors.Magenta).Bold.Append(moResponse.token).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("TransDate  - [").color(Colors.Magenta).Bold.Append(moResponse.TransactionDate).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("TransType  - [").color(Colors.Magenta).Bold.Append(moResponse.TransactionType).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("ResponseType  - [").color(Colors.Magenta).Bold.Append(moResponse.ResponseType).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("ValidationKey  - [").color(Colors.Magenta).Bold.Append(moResponse.ValidationKey).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("SigData  - [").color(Colors.Magenta).Bold.Append(moResponse.SignatureData).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("UserTip  - [").color(Colors.Magenta).Bold.Append(moResponse.UserTip).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Cashback  - [").color(Colors.Magenta).Bold.Append(moResponse.Cashback).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Donation  - [").color(Colors.Magenta).Bold.Append(moResponse.Donation).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Surcharge  - [").color(Colors.Magenta).Bold.Append(moResponse.Surcharge).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Remainingbal  - [").color(Colors.Magenta).Bold.Append(moResponse.RemainingCardBalance).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("Discount - [").color(Colors.Magenta).Bold.Append(moResponse.DiscountTotal).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("KeyedExp  - [").color(Colors.Magenta).Bold.Append(moResponse.KeyedExpDate).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("KeyedZip  - [").color(Colors.Magenta).Bold.Append(moResponse.KeyedAvsZip).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("KeyedAvsResp - [").color(Colors.Magenta).Bold.Append(moResponse.KeyedAvsResponse).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("KeyedCvResp  - [").color(Colors.Magenta).Bold.Append(moResponse.KeyedCvResponse).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("ExtraData  - [").color(Colors.Magenta).Bold.Append(moResponse.ExtraData).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("DebitTrace# - [").color(Colors.Magenta).Bold.Append(moResponse.DebitTraceNumber).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("VaultToken - [").color(Colors.Magenta).Bold.Append(moResponse.VaultToken).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("VaultErrorCode - [").color(Colors.Magenta).Bold.Append(moResponse.VaultErrorCode).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("VaultErrorMsg - [").color(Colors.Magenta).Bold.Append(moResponse.VaultErrorMsg).Pop.Pop.Append("]").Append(CRLF).PopAll
	poCS.Color(Colors.Blue).Append("VaultExpire - [").color(Colors.Magenta).Bold.Append(moResponse.VaultExpire).Pop.Pop.Append("]").Append(CRLF).PopAll

	Return poCS
End Sub


Public Sub GeniusEntryModeToAlerionEnum(sGenMode As String) As Int
	Select Case sGenMode.Trim.ToUpperCase
		Case "SWIPE"
			Return ART_EntryMode_Swipe
		Case "PROXIMITY"
			Return ART_EntryMode_Proximity
		Case "BARCODE"
			Return ART_EntryMode_Barcode
		Case "MANUAL"
			Return ART_EntryMode_Manual
		Case "NOTE"
			Return ART_EntryMode_Note
		Case Else
			Return ART_EntryMode_None
	End Select
End Sub

Public Sub AlerionEntryEnumToGeniusEntry(iAlerionEnum As Int) As String
	Select Case iAlerionEnum
		Case ART_EntryMode_Swipe
			Return "SWIPE"
		Case ART_EntryMode_Proximity
			Return "PROXIMITY"
		Case ART_EntryMode_Barcode
			Return "BARCODE"
		Case ART_EntryMode_Manual
			Return "MANUAL"
		Case ART_EntryMode_Note
			Return "NOTE"
		Case Else
			Return ""
	End Select
End Sub


Public Sub CayanPaymentTypeToCardEnum(sCayanType As String) As Int
	Select Case sCayanType.Trim.ToUpperCase
		Case "AMEX"
			Return ART_Card_AmEx
		Case "VISA"
			Return ART_Card_Visa
		Case "MASTERCARD"
			Return ART_Card_Master
		Case "DISCOVER"
			Return ART_Card_Discover
		Case "DEBIT"
			Return ART_Card_Debit
		Case "GIFT"
			Return ART_Card_Gift
		Case "EBT"
			Return ART_Card_EBT
		Case "LEVELUP"
			Return ART_Card_LevelUp
		Case "VOYAGER"
			Return ART_Card_Voyager
		Case "WEX"
			Return ART_Card_Wex
		Case "JCB"
			Return ART_Card_JCB
		Case "CUP"
			Return ART_Card_CUP
		Case "UNKNOWN"
			Return ART_Card_Other
		Case Else
			Return ART_Card_None
	End Select
End Sub

Public Sub CardEnumToCayanPaymentType(iCardEnum As Int) As String
	Select Case iCardEnum
		Case ART_Card_Visa
			Return "VISA"
		Case ART_Card_Master
			Return "MASTERCARD"
		Case ART_Card_AmEx
			Return "AMEX"
		Case ART_Card_Discover
			Return "DISCOVER"
		Case ART_Card_Debit
			Return "DEBIT"
		Case ART_Card_Gift
			Return "GIFT"
		Case ART_Card_EBT
			Return "EBT"
		Case ART_Card_LevelUp
			Return "LEVELUP"
		Case ART_Card_Voyager
			Return "VOYAGER"
		Case ART_Card_Wex
			Return "WEX"
		Case ART_Card_JCB
			Return "JCB"
		Case ART_Card_CUP
			Return "CUP"
		Case ART_Card_Other
			Return "UNKNOWN"
		Case Else
			Return ""
	End Select

End Sub


Public Sub CardEnumToHumanReadable(iCardType As Int) As String
	Select Case iCardType
		Case ART_Card_AmEx
			Return "AmEx"
		Case ART_Card_CUP
			Return "CUP"
		Case ART_Card_Debit
			Return "Debit"
		Case ART_Card_Discover
			Return "Discover"
		Case ART_Card_EBT
			Return "EBT"
		Case ART_Card_Gift
			Return "Gift Card"
		Case ART_Card_JCB
			Return "JBC"
		Case ART_Card_LevelUp
			Return "LevelUp"
		Case ART_Card_Master
			Return "Master Card"
		Case ART_Card_None
			Return "None"
		Case ART_Card_Other
			Return "Other"
		Case ART_Card_Visa
			Return "Visa"
		Case ART_Card_Voyager
			Return "Voyager"
		Case ART_Card_Wex
			Return "Wright Exp"
		Case ART_Card_PhxGift
			Return "Store Gift Card"
		Case ART_Card_PhxReward
			Return "Store Loyalty Card"
		Case ART_Card_Other
			Return "Other"
		Case ART_Card_None
			Return "None"
			
		Case Else
			Return "Unknown type: " & iCardType
	End Select
End Sub




'=================================================================================================================================
'=================================================================================================================================
'=================================================================================================================================
#Region   LOCAL METHODS 

'  used to begin trans and exit for manual keyed card entry
Private Sub BeginSwipedTrans
	Dim psRequest As String =  $"http://${msDeviceIP}:8080/v2/pos?TransportKey=${msTransportKey}&Format=XML"$
	Dim poJob As HttpJob

	poJob.Initialize("", Me)
	Try
		' send HTTP request
		poJob.GetRequest.Timeout = 180000
		Dlog("Begin swipe trans from: " & psRequest, Colors.Magenta)
		poJob.Download(psRequest)
		' wait for completion
		Wait For (poJob) JobDone(poJob As HttpJob)
		msRawDeviceResponse = poJob.GetString
		mbSwipeComplete = True
		Dlog("End swipe trans success: " & poJob.Success, Colors.Magenta)
		If poJob.Success Then
			Dim poTree As clsXmlTree = ParseXML(msRawDeviceResponse)
			If Not(mbAbort) Then
				ParseResponseXML(poTree)
			End If
		Else
			msLastError = poJob.ErrorMessage
		End If
		mbSwipeComplete = True
	Catch
		LogColor("clsCayanGenius.BeginSwipedTrans: " & LastException.Message, Colors.Red)
		msLastError = " Device Error: " & LastException.Message
	End Try
	poJob.Release
End Sub


Private Sub ParseResponseXML(oTree As clsXmlTree)
	Dim poStartNode As xtXmlElement
	Dim poAddlNode As xtXmlElement
	Dim poAmtDetail As xtXmlElement
	Dim poDiscounts As xtXmlElement
	Dim poKeyed As xtXmlElement
	
	moResponse.Initialize
	poStartNode = oTree.GetNodeFromRoot("TransactionResult")
	If poStartNode <> Null And poStartNode.IsInitialized Then
		' Root entries
		moResponse.Status = oTree.GetNodeText(poStartNode.Children, "Status")
		moResponse.AccountNumber = oTree.GetNodeText(poStartNode.Children, "AccountNumber")
		moResponse.AmountApproved = SafeDollar(oTree.GetNodeText(poStartNode.Children, "AmountApproved"))
		moResponse.AuthorizationCode = oTree.GetNodeText(poStartNode.Children, "AuthorizationCode")
		moResponse.Cardholder = oTree.GetNodeText(poStartNode.Children, "Cardholder")
		moResponse.EntryMode = oTree.GetNodeText(poStartNode.Children, "EntryMode")
		moResponse.ErrorMessage = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		moResponse.PaymentType = oTree.GetNodeText(poStartNode.Children, "PaymentType")
		moResponse.CardType = CayanPaymentTypeToCardEnum(moResponse.PaymentType)
		moResponse.Token = oTree.GetNodeText(poStartNode.Children, "Token")
		moResponse.TransactionDate = oTree.GetNodeText(poStartNode.Children, "TransactionDate")
		moResponse.TransactionType = oTree.GetNodeText(poStartNode.Children, "TransactionType")
		moResponse.TransportKey = msTransportKey
		moResponse.ResponseType = oTree.GetNodeText(poStartNode.Children, "ResponseType")
		moResponse.ValidationKey = oTree.GetNodeText(poStartNode.Children, "ValidationKey")
		'  Additional Parameters
		poAddlNode = oTree.GetNode(poStartNode.Children, "AdditionalParameters")
		If poAddlNode <> Null And poAddlNode.IsInitialized Then
			moResponse.SignatureData = oTree.GetNodeText(poAddlNode.Children, "SignatureData")
			moResponse.DebitTraceNumber = oTree.GetNodeText(poAddlNode.Children, "DebitTraceNumber")
			' amount detail
			poAmtDetail = oTree.GetNode(poAddlNode.Children, "AmountDetails")
			If poAmtDetail <> Null And poAmtDetail.IsInitialized Then
				moResponse.Cashback = SafeDollar(oTree.GetNodeText(poAmtDetail.Children, "CashBack"))
				moResponse.Donation = SafeDollar(oTree.GetNodeText(poAmtDetail.Children, "Donation"))
				moResponse.RemainingCardBalance = SafeDollar(oTree.GetNodeText(poAmtDetail.Children, "RemainingCardBalance"))
				moResponse.Surcharge = SafeDollar(oTree.GetNodeText(poAmtDetail.Children, "Surcharge"))
				moResponse.UserTip = SafeDollar(oTree.GetNodeText(poAmtDetail.Children, "UserTip"))
				' discounts
				poDiscounts = oTree.GetNode(poAmtDetail.Children, "Discount")
				If poDiscounts <> Null And poDiscounts.Children.Size > 0 Then
					WalkDiscounts(poDiscounts.Children)
				End If
			End If
			' keyed data
			poKeyed = oTree.GetNode(poAddlNode.Children, "KeyedDetails")
			If poKeyed <> Null And poKeyed.IsInitialized Then
				moResponse.KeyedAvsResponse = oTree.GetNodeText(poKeyed.Children, "AvsResponse")
				moResponse.KeyedAvsZip = oTree.GetNodeText(poKeyed.Children, "AvsStreetZipCode")
				moResponse.KeyedCvResponse = oTree.GetNodeText(poKeyed.Children, "CvResponse")
				moResponse.KeyedExpDate = oTree.GetNodeText(poKeyed.Children, "ExpirationDate")
			End If
		End If
	Else
		moResponse.Status = "UNDEFINED"
		moResponse.EntryMode = ""
	End If
End Sub


Private Sub ParseSaleResponseXML(oTree As clsXmlTree)
	Dim poStartNode As xtXmlElement
	
	moResponse.Initialize
	poStartNode = oTree.GetNodeFromRoot("SaleResult")
	If poStartNode <> Null And poStartNode.IsInitialized Then
		' Root entries
		moResponse.Status = oTree.GetNodeText(poStartNode.Children, "ApprovalStatus")
		moResponse.AccountNumber = oTree.GetNodeText(poStartNode.Children, "CardNumber")
		moResponse.AmountApproved = SafeDollar(oTree.GetNodeText(poStartNode.Children, "Amount"))
		moResponse.AuthorizationCode = oTree.GetNodeText(poStartNode.Children, "AuthorizationCode")
		moResponse.Cardholder = oTree.GetNodeText(poStartNode.Children, "Cardholder")
		moResponse.EntryMode = oTree.GetNodeText(poStartNode.Children, "ReaderEntryMode")
		moResponse.ErrorMessage = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		moResponse.CardType = CayanPaymentTypeToCardEnum(moResponse.PaymentType)
		moResponse.Token = oTree.GetNodeText(poStartNode.Children, "Token")
		moResponse.TransactionDate = oTree.GetNodeText(poStartNode.Children, "TransactionDate")
		moResponse.TransactionType = Trans_Sale
		moResponse.TransportKey = ""
		moResponse.KeyedAvsResponse = oTree.GetNodeText(poStartNode.Children, "AvsResponse")
		moResponse.KeyedCvResponse = oTree.GetNodeText(poStartNode.Children, "CvResponse")
		moResponse.ExtraData = oTree.GetNodeText(poStartNode.Children, "ExtraData")
		moResponse.DebitTraceNumber = oTree.GetNodeText(poStartNode.Children, "DebitTraceNumber")
		moResponse.RemainingCardBalance = SafeDollar(oTree.GetNodeText(poStartNode.Children, "RemainingCardBalance"))
	Else
		moResponse.Status = "UNDEFINED"
		moResponse.EntryMode = ""
	End If
End Sub


Private Sub ParseVoidResponseXML(oTree As clsXmlTree)
	Dim poStartNode As xtXmlElement
	
	moResponse.Initialize
	poStartNode = oTree.GetNodeFromRoot("VoidResult")
	If poStartNode <> Null And poStartNode.IsInitialized Then
		' Root entries
		moResponse.Status = oTree.GetNodeText(poStartNode.Children, "ApprovalStatus")
		moResponse.AuthorizationCode = oTree.GetNodeText(poStartNode.Children, "AuthorizationCode")
		moResponse.Token = oTree.GetNodeText(poStartNode.Children, "Token")
		moResponse.TransactionDate = oTree.GetNodeText(poStartNode.Children, "TransactionDate")
		moResponse.AmountApproved = SafeDollar(oTree.GetNodeText(poStartNode.Children, "Amount"))
		moResponse.RemainingCardBalance = SafeDollar(oTree.GetNodeText(poStartNode.Children, "RemainingCardBalance"))
		moResponse.AccountNumber = oTree.GetNodeText(poStartNode.Children, "CardNumber")
		moResponse.Cardholder = oTree.GetNodeText(poStartNode.Children, "Cardholder")
		moResponse.PaymentType = oTree.GetNodeText(poStartNode.Children, "CardType")
		moResponse.ErrorMessage = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		moResponse.KeyedAvsResponse = oTree.GetNodeText(poStartNode.Children, "AvsResponse")
		moResponse.KeyedCvResponse = oTree.GetNodeText(poStartNode.Children, "CvResponse")
		moResponse.ExtraData = oTree.GetNodeText(poStartNode.Children, "ExtraData")
		moResponse.DebitTraceNumber = oTree.GetNodeText(poStartNode.Children, "DebitTraceNumber")
	Else
		moResponse.Status = "UNDEFINED"
		moResponse.EntryMode = ""
	End If
End Sub

Private Sub ParseRefundResponseXML(oTree As clsXmlTree)
	Dim poStartNode As xtXmlElement
	
	moResponse.Initialize
	poStartNode = oTree.GetNodeFromRoot("RefundResult")
	If poStartNode <> Null And poStartNode.IsInitialized Then
		' Root entries
		moResponse.Status = oTree.GetNodeText(poStartNode.Children, "ApprovalStatus")
		moResponse.AuthorizationCode = oTree.GetNodeText(poStartNode.Children, "AuthorizationCode")
		moResponse.Token = oTree.GetNodeText(poStartNode.Children, "Token")
		moResponse.TransactionDate = oTree.GetNodeText(poStartNode.Children, "TransactionDate")
		moResponse.AmountApproved = SafeDollar(oTree.GetNodeText(poStartNode.Children, "Amount"))
		moResponse.RemainingCardBalance = SafeDollar(oTree.GetNodeText(poStartNode.Children, "RemainingCardBalance"))
		moResponse.AccountNumber = oTree.GetNodeText(poStartNode.Children, "CardNumber")
		moResponse.Cardholder = oTree.GetNodeText(poStartNode.Children, "Cardholder")
		moResponse.PaymentType = oTree.GetNodeText(poStartNode.Children, "CardType")
		moResponse.ErrorMessage = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		moResponse.KeyedAvsResponse = oTree.GetNodeText(poStartNode.Children, "AvsResponse")
		moResponse.KeyedCvResponse = oTree.GetNodeText(poStartNode.Children, "CvResponse")
		moResponse.ExtraData = oTree.GetNodeText(poStartNode.Children, "ExtraData")
		moResponse.DebitTraceNumber = oTree.GetNodeText(poStartNode.Children, "DebitTraceNumber")
	Else
		moResponse.Status = "UNDEFINED"
		moResponse.EntryMode = ""
	End If
End Sub





Private Sub ParseBoardResponseXML(oTree As clsXmlTree)
	Dim poStartNode As xtXmlElement
	Dim piIntVal As Int = 0
	
	moResponse.Initialize
	poStartNode = oTree.GetNodeFromRoot("BoardCardResult")
	If poStartNode <> Null And poStartNode.IsInitialized Then
		' Root entries
		moResponse.VaultToken = oTree.GetNodeText(poStartNode.Children, "VaultToken")
		moResponse.VaultErrorCode = oTree.GetNodeText(poStartNode.Children, "ErrorCode")
		moResponse.VaultErrorMsg = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		If IsNumber(moResponse.VaultErrorCode) Then
			piIntVal = moResponse.VaultErrorCode
		End If
		If moResponse.VaultToken.Trim <> "" And piIntVal = 0 Then
			moResponse.Status = "SUCCESS"
		Else
			moResponse.Status = "FAILED"
		End If
	Else
		moResponse.Status = "UNDEFINED"
		moResponse.EntryMode = ""
	End If
End Sub

Private Sub ParseUnboardResponseXML(oTree As clsXmlTree)
	Dim poStartNode As xtXmlElement
	Dim piIntVal As Int = 0
	
	moResponse.Initialize
	poStartNode = oTree.GetNodeFromRoot("UnboardCardResult")
	If poStartNode <> Null And poStartNode.IsInitialized Then
		' Root entries
		moResponse.VaultToken = oTree.GetNodeText(poStartNode.Children, "VaultToken")
		moResponse.VaultErrorCode = oTree.GetNodeText(poStartNode.Children, "ErrorCode")
		moResponse.VaultErrorMsg = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		If IsNumber(moResponse.VaultErrorCode) Then
			piIntVal = moResponse.VaultErrorCode
		End If
		If moResponse.VaultToken.Trim <> "" And piIntVal = 0 Then
			moResponse.Status = "SUCCESS"
		Else
			moResponse.Status = "FAILED"
		End If
	Else
		moResponse.Status = "UNDEFINED"
		moResponse.EntryMode = ""
	End If
End Sub


Private Sub ParseFindBoardedCardResponseXML(oTree As clsXmlTree)
	Dim poStartNode As xtXmlElement
	Dim psType As String
	
	moResponse.Initialize
	poStartNode = oTree.GetNodeFromRoot("FindBoardedCardResult")
	If poStartNode <> Null And poStartNode.IsInitialized Then
		' Root entries
		moResponse.AccountNumber = oTree.GetNodeText(poStartNode.Children, "CardNumber")
		moResponse.VaultExpire = oTree.GetNodeText(poStartNode.Children, "ExpirationDate")
		moResponse.Cardholder = oTree.GetNodeText(poStartNode.Children, "Cardholder")
		psType = oTree.GetNodeText(poStartNode.Children, "CardType")
		If Not(IsNumber(psType)) Then
			moResponse.CardType = "UNKNOWN"
		Else
			moResponse.CardType = psType
		End If
		moResponse.VaultErrorCode = oTree.GetNodeText(poStartNode.Children, "ErrorCode")
		moResponse.VaultErrorMsg = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		If moResponse.AccountNumber.Trim <> "" Then
			moResponse.Status = "SUCCESS"
		Else
			moResponse.Status = "FAILED"
			moResponse.VaultErrorCode = oTree.GetNodeText(poStartNode.Children, "ErrorCode")
			moResponse.VaultErrorMsg = oTree.GetNodeText(poStartNode.Children, "ErrorMessage")
		End If
	Else
		moResponse.Status = "UNDEFINED"
		moResponse.EntryMode = ""
	End If
End Sub


Private Sub WalkDiscounts(oNode As List)
	For Each poEle As xtXmlElement In oNode
		If poEle.Name.Trim.ToLowerCase = "total" Then
			If Not(poEle.Children.IsInitialized) Or poEle.Children.Size = 0 Then
				If poEle.Text <> "" Then
					moResponse.DiscountTotal = moResponse.DiscountTotal + SafeDollar(poEle.Text)
				End If
			Else
				WalkDiscounts(poEle.Children)
			End If
		End If
	Next
End Sub



Private Sub BuildStageTransXML(StageParams As cgStageParmeters) As String
	Dim poTree As clsXmlTree
	Dim poRoot As xtXmlElement
	
	poTree.Initialize
	poRoot = poTree.InitializeTree
	Dim poCreate As xtXmlElement = poTree.NewElement("CreateTransaction")
	poCreate.Attributes.Put("xmlns", "http://transport.merchantware.net/v4/")
	Dim poNode As xtXmlElement = poTree.NewElement("merchantName")
	poNode.Text = msMerchantName
	poCreate.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("merchantSiteId")
	poNode.Text = msMerchantSiteID
	poCreate.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("merchantKey")
	poNode.Text = msMerchantKey
	poCreate.Children.Add(poNode)
	' build request for create node
	Dim poRequest As xtXmlElement = poTree.NewElement("request")
	Dim poNode As xtXmlElement = poTree.NewElement("TransactionType")
	Select Case StageParams.TransType
		Case Trans_Sale
			poNode.Text= "SALE"
		Case Trans_Refund
			poNode.Text= "_REFUND"
		Case Trans_Level2Sale
			poNode.Text= "LEVEL2SALE"
		Case Trans_PreAuth
			poNode.Text= "PREAUTH"
		Case Trans_ForceSale
			poNode.Text= "FORCESALE"
		Case Trans_AddValue
			poNode.Text= "ADDVALUE"
		Case Trans_BalanceInquiry
			poNode.Text= "BALANCEINQUIRY"
		Case Else
			poNode.Text= "SALE"
	End Select
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("Amount")
	poNode.Text = NumberFormat2(StageParams.Amount, 1, 2, 2, False)
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("ClerkId")
	poNode.Text = StageParams.ClerkID
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("OrderNumber")
	poNode.Text = StageParams.InvoiceNumber
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("Dba")
	poNode.Text = StageParams.DBA
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("SoftwareName")
	poNode.Text = SOFTWARE_NAME
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("SoftwareVersion")
	poNode.Text = INTERFACE_VERSION
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("TransactionId")
	poNode.Text = StageParams.TransactionId
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("ForceDuplicate")
	If StageParams.ForceDuplicate Then
		poNode.Text = "true"
	Else
		poNode.Text = "false"
	End If
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("CustomerCode")
	poNode.Text = StageParams.CustomerCode
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("PoNumber")
	poNode.Text = StageParams.PONumber
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("TaxAmount")
	poNode.Text = NumberFormat2(StageParams.TaxAmount, 1, 2, 2, False)
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("TerminalId")
	poNode.Text = NumberFormat2(StageParams.TerminalID, 2, 0, 0, False)
	poRequest.Children.Add(poNode)
	If StageParams.AuthCode <> "" Then
		Dim poNode As xtXmlElement = poTree.NewElement("AuthorizationCode")
		poNode.Text = StageParams.AuthCode
		poRequest.Children.Add(poNode)
	End If
	If StageParams.EligibleTipAmount > 0 Then
		Dim poTip As xtXmlElement = poTree.NewElement("TipDetails")
		Dim poTipAmt As xtXmlElement = poTree.NewElement("EligibleAmount")
		poTipAmt.Text = NumberFormat2(StageParams.EligibleTipAmount, 1, 2, 2, False)
		poTip.Children.Add(poTipAmt)
		poRequest.Children.Add(poTip)
	End If
	Dim poCardOnFile As xtXmlElement = poTree.NewElement("CardOnFileDetails")
	If StageParams.StoreCardInVault Then
		Dim poNode As xtXmlElement = poTree.NewElement("StoreCardInVault")
		poNode.Text = "true"
		poCardOnFile .Children.Add(poNode)
		Dim poNode As xtXmlElement = poTree.NewElement("StoreCardReason")
		poNode.Text = "UNSCHEDULEDCIT"
		poCardOnFile .Children.Add(poNode)
	Else
		Dim poNode As xtXmlElement = poTree.NewElement("StoreCardInVault")
		poNode.Text = "false"
		poCardOnFile .Children.Add(poNode)
	End If
	poRequest.Children.Add(poCardOnFile)
	
	' Put request into create
	poCreate.Children.Add(poRequest)
	' Put create into root
	poRoot.Children.Add(poCreate)
	
	If ShowDebugXML Then
		LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(180, 40, 40))
	End If
	Return poTree.ToXML(1, ShowDebugLog)
End Sub

Private Sub BuildApiVaultSaleXML(VaultParams As cgVaultParmeters) As String
	Dim poTree As clsXmlTree
	Dim poRoot As xtXmlElement
	
	poTree.Initialize
	poRoot = poTree.InitializeTree
	Dim poSale As xtXmlElement = poTree.NewElement("Sale")
	poSale.Attributes.Put("xmlns", "http://schemas.merchantwarehouse.com/merchantware/v46/")

	' credentials
	AddCredentialsToRequest(poTree, poSale)

	' payment data
	Dim poPayData As xtXmlElement = poTree.NewElement("PaymentData")
	Dim poNode As xtXmlElement = poTree.NewElement("Source")
	poNode.Text = "VAULT"
	poPayData.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("VaultToken")
	poNode.Text = VaultParams.VaultToken
	poPayData.Children.Add(poNode)
	
	' request
	Dim poRequest As xtXmlElement = poTree.NewElement("Request")
	Dim poNode As xtXmlElement = poTree.NewElement("Amount")
	poNode.Text = NumberFormat2(VaultParams.Amount, 1, 2, 2, False)
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("TaxAmount")
	poNode.Text = NumberFormat2(VaultParams.TaxAmount, 1, 2, 2, False)
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("CustomerCode")
	poNode.Text = VaultParams.CustomerCode
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("InvoiceNumber")
	poNode.Text = VaultParams.InvoiceNumber
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("RegisterNumber")
	poNode.Text = VaultParams.TerminalID
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("MerchantTransactionId")
	poNode.Text = VaultParams.TransactionId
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("ForceDuplicate")
	If VaultParams.ForceDuplicate Then
		poNode.Text = "true"
	Else
		poNode.Text = "false"
	End If
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("EnablePartialAuthorization")
	If VaultParams.EnablePartialAuth Then
		poNode.Text = "true"
	Else
		poNode.Text = "false"
	End If
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("StoredCardReason")
	poNode.Text = "UNSCHEDULEDCIT"
	poRequest.Children.Add(poNode)

	' add payment data to sale
	poSale.Children.Add(poPayData)
	' add request to sale
	poSale.Children.Add(poRequest)
	' Put sale into root
	poRoot.Children.Add(poSale)

	If ShowDebugXML Then
		LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(180, 40, 40))
	End If
	' return soap12 envelope
	Return poTree.ToXML(2, ShowDebugLog)
End Sub




Private Sub BuildApiVoidRequestXML(VaultParms As cgVaultParmeters) As String
	Dim poTree As clsXmlTree
	Dim poRoot As xtXmlElement
	
	poTree.Initialize
	poRoot = poTree.InitializeTree
	Dim poVoid As xtXmlElement = poTree.NewElement("Void")
	poVoid.Attributes.Put("xmlns", "http://schemas.merchantwarehouse.com/merchantware/v46/")
	' credentials
	AddCredentialsToRequest(poTree, poVoid)
	' request
	Dim poRequest As xtXmlElement = poTree.NewElement("Request")
	Dim poNode As xtXmlElement = poTree.NewElement("Token")
	poNode.Text = VaultParms.VaultToken
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("RegisterNumber")
	poNode.Text = VaultParms.TerminalID
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("MerchantTransactionId")
	poNode.Text = VaultParms.TransactionId
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("CardAcceptorTerminalId")
	poNode.Text = ""
	poRequest.Children.Add(poNode)
	' add request to void
	poVoid.Children.Add(poRequest)
	' Put void into root
	poRoot.Children.Add(poVoid)

	If ShowDebugXML Then
		LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(180, 40, 40))
	End If
	' return soap12 envelope
	Return poTree.ToXML(2, ShowDebugLog)
End Sub

Private Sub BuildApiRefundRequestXML(VaultParms As cgVaultParmeters) As String
	Dim poTree As clsXmlTree
	Dim poRoot As xtXmlElement
	
	poTree.Initialize
	poRoot = poTree.InitializeTree
	Dim poRefund As xtXmlElement = poTree.NewElement("Refund")
	poRefund.Attributes.Put("xmlns", "http://schemas.merchantwarehouse.com/merchantware/v46/")
	' credentials
	AddCredentialsToRequest(poTree, poRefund)
	' payment data
	Dim poPayData As xtXmlElement = poTree.NewElement("PaymentData")
	Dim poNode As xtXmlElement = poTree.NewElement("Source")
	poNode.Text = "PREVIOUSTRANSACTION"
	poPayData.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("Token")
	poNode.Text = VaultParms.VaultToken
	poPayData.Children.Add(poNode)
	' add paydata to refund
	poRefund.Children.Add(poPayData)
	' request
	Dim poRequest As xtXmlElement = poTree.NewElement("Request")
	Dim poNode As xtXmlElement = poTree.NewElement("Amount")
	poNode.Text = NumberFormat2(VaultParms.Amount, 1, 2, 2, False)
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("InvoiceNumber")
	poNode.Text = VaultParms.InvoiceNumber
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("RegisterNumber")
	poNode.Text = VaultParms.TerminalID
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("MerchantTransactionId")
	poNode.Text = VaultParms.TransactionId
	poRequest.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("CardAcceptorTerminalId")
	poNode.Text = ""
	poRequest.Children.Add(poNode)
	' add request to void
	poRefund.Children.Add(poRequest)
	' Put refund into root
	poRoot.Children.Add(poRefund)

	If ShowDebugXML Then
		LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(180, 40, 40))
	End If
	' return soap12 envelope
	Return poTree.ToXML(2, ShowDebugLog)
End Sub


'  <b>NOTE:</b>  THIS FUNCTION IS CURRENTLY USING API 4.5 AND NOT API 4.6 and using SOAP: not SOAP12: tags.
Private Sub BuildApiBoardRequestXML(Token As String) As String
	Dim poTree As clsXmlTree
	Dim poRoot As xtXmlElement
	
	poTree.Initialize
	poRoot = poTree.InitializeTree
	Dim poBoard As xtXmlElement = poTree.NewElement("BoardCard")
	poBoard.Attributes.Put("xmlns", "http://schemas.merchantwarehouse.com/merchantware/v45/")
	' credentials
	AddCredentialsToRequest(poTree, poBoard)
	' payment data
	Dim poPayData As xtXmlElement = poTree.NewElement("PaymentData")
	Dim poNode As xtXmlElement = poTree.NewElement("Source")
	poNode.Text = "PreviousTransaction"
	poPayData.Children.Add(poNode)
	Dim poNode As xtXmlElement = poTree.NewElement("Token")
	poNode.Text = Token
	poPayData.Children.Add(poNode)
	' add payment data to boardcard
	poBoard.Children.Add(poPayData)
	' Put board into root
	poRoot.Children.Add(poBoard)

	If ShowDebugXML Then
		LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(180, 40, 40))
	End If
	' return soap envelope
	Return poTree.ToXML(1, ShowDebugLog)
End Sub

Private Sub BuildApiUnboardRequestXML(VaultToken As String) As String
	Dim poTree As clsXmlTree
	Dim poRoot As xtXmlElement
	
	poTree.Initialize
	poRoot = poTree.InitializeTree
	Dim poUnboard As xtXmlElement = poTree.NewElement("UnboardCard")
	poUnboard.Attributes.Put("xmlns", "http://schemas.merchantwarehouse.com/merchantware/v46/")
	' credentials
	AddCredentialsToRequest(poTree, poUnboard)
	' Request data
	Dim poRequest As xtXmlElement = poTree.NewElement("Request")
	Dim poNode As xtXmlElement = poTree.NewElement("VaultToken")
	poNode.Text = VaultToken
	poRequest.Children.Add(poNode)
	' add request to unboard
	poUnboard.Children.Add(poRequest)
	' Put unboard into root
	poRoot.Children.Add(poUnboard)

	If ShowDebugXML Then
		LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(180, 40, 40))
	End If
	' return soap12 envelope
	Return poTree.ToXML(2, ShowDebugLog)
End Sub


Private Sub BuildApiFindBoardedCardRequestXML(VaultToken As String) As String
	Dim poTree As clsXmlTree
	Dim poRoot As xtXmlElement
	
	poTree.Initialize
	poRoot = poTree.InitializeTree
	Dim poUnboard As xtXmlElement = poTree.NewElement("FindBoardedCard")
	poUnboard.Attributes.Put("xmlns", "http://schemas.merchantwarehouse.com/merchantware/v46/")
	' credentials
	AddCredentialsToRequest(poTree, poUnboard)
	' payment data
	Dim poRequest As xtXmlElement = poTree.NewElement("Request")
	Dim poNode As xtXmlElement = poTree.NewElement("VaultToken")
	poNode.Text = VaultToken
	poRequest.Children.Add(poNode)
	' add request to unboard
	poUnboard.Children.Add(poRequest)
	' Put unboard into root
	poRoot.Children.Add(poUnboard)

	If ShowDebugXML Then
		LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(180, 40, 40))
	End If
	' return soap12 envelope
	Return poTree.ToXML(2, ShowDebugLog)
End Sub








'  Adds a "Credentials" node to the supplied node.
Private Sub AddCredentialsToRequest(oTree As clsXmlTree, oRequestNode As xtXmlElement)
	Dim poCredentials As xtXmlElement = oTree.NewElement("Credentials")
	Dim poNode As xtXmlElement = oTree.NewElement("MerchantName")
	poNode.Text = msMerchantName
	poCredentials.Children.Add(poNode)
	Dim poNode As xtXmlElement = oTree.NewElement("MerchantSiteId")
	poNode.Text = msMerchantSiteID
	poCredentials.Children.Add(poNode)
	Dim poNode As xtXmlElement = oTree.NewElement("MerchantKey")
	poNode.Text = msMerchantKey
	poCredentials.Children.Add(poNode)
	oRequestNode.Children.Add(poCredentials)
End Sub


Private Sub ParseXML(XmlString As String) As clsXmlTree
	Dim poTree As clsXmlTree
	poTree.Initialize
	If Not(poTree.Parse(XmlString)) Then
		LogColor("clsCayanGenius: Failed to parse XML to tree: " & CRLF & XmlString & CRLF, Colors.Red)
		poTree.InitializeTree
	Else
		If ShowDebugXML Then
			LogColor(poTree.ToXMLFromNode("root", 0, True), Colors.RGB(30, 140, 30))
		End If
	End If
	Return poTree
End Sub


Private Sub BuildStagingURL(ParamList As Map) As String
	Dim poURL As StringBuilder
	poURL.Initialize
	poURL.Append(STAGING_ENDPOINT)
	If ParamList <> Null And ParamList.IsInitialized And ParamList.Size > 0 Then
		poURL.append("?").Append(ParamList.GetKeyAt(0)).Append("=").Append(ParamList.GetValueAt(0))
		Dim piIndex As Int
		For piIndex = 1 To ParamList.Size - 1
			poURL.append("&").Append(ParamList.GetKeyAt(piIndex)).Append("=").Append(ParamList.GetValueAt(piIndex))
		Next
	End If
	Return poURL.ToString
End Sub

Private Sub BuildCreditURL(ParamList As Map) As String
	Dim poURL As StringBuilder
	poURL.Initialize
	poURL.Append(CREDIT_ENDPOINT)
	If ParamList <> Null And ParamList.IsInitialized And ParamList.Size > 0 Then
		poURL.append("?").Append(ParamList.GetKeyAt(0)).Append("=").Append(ParamList.GetValueAt(0))
		Dim piIndex As Int
		For piIndex = 1 To ParamList.Size - 1
			poURL.append("&").Append(ParamList.GetKeyAt(piIndex)).Append("=").Append(ParamList.GetValueAt(piIndex))
		Next
	End If
	Return poURL.ToString
End Sub

Private Sub BuildCredit45URL(ParamList As Map) As String
	Dim poURL As StringBuilder
	poURL.Initialize
	poURL.Append(CREDIT_ENDPOINT_45)
	If ParamList <> Null And ParamList.IsInitialized And ParamList.Size > 0 Then
		poURL.append("?").Append(ParamList.GetKeyAt(0)).Append("=").Append(ParamList.GetValueAt(0))
		Dim piIndex As Int
		For piIndex = 1 To ParamList.Size - 1
			poURL.append("&").Append(ParamList.GetKeyAt(piIndex)).Append("=").Append(ParamList.GetValueAt(piIndex))
		Next
	End If
	Return poURL.ToString
End Sub


Private Sub SafeDollar(sVal As String) As Double
	Dim pdVal As Double  = 0
	Dim piIntVal As Int
	
	If sVal.Trim <> "" Then
		Try
			pdVal = sVal.Trim
			piIntVal = pdVal * 100
			pdVal = piIntVal / 100
		Catch
			pdVal = 0
		End Try
	End If
	Return pdVal
End Sub

Private Sub Dlog(Message As Object, Color As Int)
	If ShowDebugLog Then
		LogColor(Message, Color)
	End If
End Sub


#End Region   LOCAL METHODS 




#Region   PUBLIC PROPERTIES

Public Sub getDeviceIP As String
	Return msDeviceIP
End Sub

Public Sub getMerchantName As String
	Return msMerchantName
End Sub

Public Sub getMerchantSiteID As String
	Return msMerchantSiteID
End Sub

Public Sub getMerchantKey As String
	Return msMerchantKey
End Sub

Public Sub getResponse As cgResultParms
	Return moResponse
End Sub

Public Sub getRawResponse As String
	Return msRawResponse
End Sub

Public Sub getRawDeviceResponse As String
	Return msRawDeviceResponse
End Sub

Public Sub getLastErrorMessage As String
	Return msLastError
End Sub

Public Sub LastTransportKey As String
	Return msTransportKey
End Sub

Public Sub LastValidationKey As String
	Return msValidationKey
End Sub

Public Sub getAccountLastFour As String
	If moResponse.AccountNumber.Length > 4 Then
		Return moResponse.AccountNumber.SubString(moResponse.AccountNumber.Length - 4)
	Else
		Return moResponse.AccountNumber
	End If
End Sub

' Returns a LIST of cgPoints of the signature
Public Sub SignaturePoints As List
	Dim poList As List
	
	poList.Initialize
	If moResponse.SignatureData.Length > 0 Then
		Dim psPairs() As String = Regex.Split("\^|\~", moResponse.SignatureData)
		For Each psPair In psPairs
			Dim psPnt() As String = Regex.Split("\,", psPair)
			If psPnt.Length = 2 Then
				Dim poPnt As cgPoint
				poPnt.Initialize
				poPnt.X = psPnt(0)
				poPnt.Y = psPnt(1)
				poList.Add(poPnt)
			End If
		Next
	End If
	Return poList
End Sub

Public Sub TransactionApproved As Boolean
	Select Case moResponse.Status.Trim.ToUpperCase
		Case "APPROVED"
			Return True

		Case Else
			Return False
	End Select
End Sub



#End Region   PUBLIC PROPERTIES








