﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=11.5
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals


End Sub



Public Sub MyLog(Message As String)
	If Starter.DEBUG_MODE Then
		LogColor(Message, Colors.Magenta)
	End If
End Sub

' Logs in green text.
Public Sub MyLogG(Message As String)
	If Starter.DEBUG_MODE Then
		LogColor(Message, Colors.RGB(30, 128, 30))
	End If
End Sub

' Logs in blue text
Public Sub MyLogB(Message As String)
	If Starter.DEBUG_MODE Then
		LogColor(Message, Colors.RGB(40, 40, 180))
	End If
End Sub

' Logs in red and logs regardless of debug state as well as logging to Starter.ERROR_LOG_FILE in the working folder.
Public Sub MyLogError(ModuleName As String, Message As String)
	Dim psLine As String
	psLine = ">>>" & "[" & ModuleName & "] " & Message
	LogColor(psLine, Colors.Red)
	If Not(Starter.DEBUG_MODE) Then
		Try
			Dim poTW As TextWriter
			poTW.Initialize(File.OpenOutput(Starter.WorkingFolder, Starter.ERROR_LOG_FILE, True))
			psLine = $"$DateTime{DateTime.Now}|${ModuleName}: ${Message}"$
			poTW.WriteLine(psLine)
			poTW.Close
		Catch
			' don't care
		End Try		'ignore
	End If
End Sub